#ifndef AVERAGE__HPP
#define AVERAGE__HPP

namespace doj
{

  template <typename T, unsigned max=16>
  class Average
  {
    T a[max];
    unsigned i;

  public:
    Average() : i(0)
    {
      erase();
    }

    void push(const T& t)
    {
      if(i<max)
	a[i++]=t;
    }

    void erase()
    {
      for(unsigned z=0; z!=max; ++z)
	a[z]=0;
      i=0;
    }

    T avg() const
    {
      T t(0);
      for(unsigned z=0; z!=max; ++z)
	t+=a[z];
      return t/max;
    }

    unsigned size() const { return max; }

    bool empty() const { return i==0; }
    bool full() const { return i>=max; }

  };

}

#endif
