/*
  sid (c) 1999-2004 by Dirk Jagdmann <doj@cubic.org>

  This file is part of sid.

  sid is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  sid is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
  License for more details.

  You should have received a copy of the GNU General Public License
  along with sid; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

  $Header: /code/cw/sid/sid.h,v 1.7 2005/01/20 19:58:35 doj Exp $
*/

#ifndef SID__H
#define SID__H

#include <cwsid.h>

#include "defines.h"

#pragma pack(push, 1)

/// structure describing one SID voice. It is mapping directly to SID registers
struct SIDvoice
{
  byte freqLo;
  byte freqHi;
  byte pwLo;
  byte pwHi;

  unsigned int gate:1;
  unsigned int sync:1;
  unsigned int ring:1;
  unsigned int test:1;
  unsigned int tri:1;
  unsigned int saw:1;
  unsigned int squ:1;
  unsigned int nse:1;

  unsigned int decay:4;
  unsigned int attack:4;

  unsigned int release:4;
  unsigned int sustain:4;
};

/// structure describing a SID. It is mapping directly to SID registers
struct SID
{
  struct SIDvoice voice[3];
  byte filtLo;
  byte filtHi;

  unsigned int filt1:1;
  unsigned int filt2:1;
  unsigned int filt3:1;
  unsigned int filtEx:1;
  unsigned int resonance:4;

  unsigned int vol:4;
  unsigned int lowpass:1;
  unsigned int bandpass:1;
  unsigned int highpass:1;
  unsigned int off3:1;

  byte potx;
  byte poty;
  byte osc3;
  byte env3;
};

#define SID_MAX_NUM 2

/// structure containing CWSID_MAX_NUM SIDs. CWSID_MAX_NUM is defined in cwsid.h
struct allSID
{
  SID sid[SID_MAX_NUM];
};

#pragma pack(pop)

#endif
